'use strict';

module.exports = function(fn, customErrorHandlingFunction) {
  return function(req, res, next) {
    return fn(req, res, next).catch(function(err) {
      if(customErrorHandlingFunction && customErrorHandlingFunction instanceof Function){
        return customErrorHandlingFunction(req, res, next, err);
      } else {
        return next(err);
      }
    });
  };
};
